unit lut;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Spin, Buttons,ClipBrd, ComCtrls, ToolWin;
const
     kBinMax = 255;
     kBorder = 16;
     kRectSz = 255;
type
    ByteRA = array [1..1] of byte;
    Bytep = ^ByteRA;
    TLUT = array [0..kBinMax] of byte;
    TForm1 = class(TForm)
    ImageSrc: TImage;
    ImageLUT: TImage;
    BMPImage: TImage;
    OpenDialog1: TOpenDialog;
    RBias: TTrackBar;
    GBias: TTrackBar;
    BBias: TTrackBar;
    RBtn: TPanel;
    GBtn: TPanel;
    BBtn: TPanel;
    RGain: TTrackBar;
    GGain: TTrackBar;
    BGain: TTrackBar;
    SpeedButton2: TSpeedButton;
    ToolBar1: TToolBar;
    OpenBMPBtn: TSpeedButton;
    CopyBtn: TSpeedButton;
    ClearBtn: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SaveBtn: TSpeedButton;
    RandBtn: TSpeedButton;
    SaveDialog1: TSaveDialog;
    DepCheck: TCheckBox;
    LUT2txt: TSpeedButton;
    OpenDialog2: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure DrawInput(lHt,lWid: integer);
    procedure CopyInput;
    procedure SetDimensionGrayscale(lImage: TImage; lPGHt,lPGWid: integer;  lBuff: ByteP);
    procedure FormDestroy(Sender: TObject);
    procedure ShowLUT;
    procedure OpenBMPBtnClick(Sender: TObject);
    procedure CopyBtnClick(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure RBiasChange(Sender: TObject);
    procedure ResetClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure RandBtnClick(Sender: TObject);
    procedure RBtnClick(Sender: TObject);
    procedure GBtnClick(Sender: TObject);
    procedure BBtnClick(Sender: TObject);
    procedure LUT2txtClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
   gRLUT,gGLUT,gBLUT : TLUT;

var
  Form1: TForm1;
  gBuff: bytep;
  gSrcWid,gSrcHt: integer;

implementation

{$R *.DFM}
procedure TForm1.SetDimensionGrayscale(lImage: TImage; lPGHt,lPGWid: integer;  lBuff: ByteP);
  VAR
   PixMap: pointer;
   Bmp     : TBitmap;
   hBmp    : HBITMAP;
   BI      : PBitmapInfo;
   BIH     : TBitmapInfoHeader;
   lPixmapInt,lBuffInt: integer ;
   ImagoDC : hDC;
   I,lScanLineSz,lScanLineSz8: integer;
  BEGIN
     BIH.biSize := Sizeof(BIH);
     BIH.biWidth := lPGwid;
     BIH.biHeight := lPGHt;
     BIH.biPlanes := 1;
     BIH.biBitCount := 8;
     BIH.biCompression := BI_RGB;
     BIH.biSizeImage := 0;
     BIH.biXPelsPerMeter := 0;
     BIH.biYPelsPerMeter := 0;
     BIH.biClrUsed := 0;
     BIH.biClrImportant := 0;
     BI := AllocMem(SizeOf(TBitmapInfoHeader) + 256*Sizeof(TRGBQuad));
     BI^.bmiHeader := BIH;
         for I:=0 to 255 do begin

             BI^.bmiColors[I].rgbRed     := gRLUT[I];
             BI^.bmiColors[I].rgbGreen    := gGLUT[I];
             BI^.bmiColors[I].rgbBlue      := gBLUT[I];
             BI^.bmiColors[I].rgbReserved := 0;
         end;
     Bmp        := TBitmap.Create;
     Bmp.Height := lPGHt{width};
     Bmp.Width  := lPGwid;
     ImagoDC := GetDC(Self.Handle);
     hBmp:= CreateDIBSection(imagodc,bi^,DIB_RGB_COLORS,pixmap,0,0);
     lScanLineSz := lPGwid;
     if(lPGwid mod 4) <> 0 then
               lScanLineSz8 := 4*((lPGWid + 3)div 4)
     else lScanLineSz8 := lPGwid;
     if lBuff <> nil then begin
        lPixmapInt  := Integer(pixmap);
        lBuffInt := Integer(lBuff);
           For i:= (Bmp.Height-1)  downto 0 do
               CopyMemory(Pointer(lPixmapInt+lScanLineSz8*(i)),
                     Pointer(lBuffInt+i*lScanLineSz),lScanLineSz);
     end; //lBuff full
     ReleaseDC(0,ImagoDC);
     Bmp.Handle := hBmp;
     lImage.Picture.Assign(Bmp);
     lImage.width := Bmp.Width ;
     lImage.height := Bmp.Height;
     Bmp.Free;
     FreeMem( BI);
end;

procedure TForm1.DrawInput(lHt,lWid: integer);
var
   lX,lI,lR,lPos: integer;
begin
     freemem(gBuff);
     gSrcHt := lHt;
     gSrcWid := lWid;
     getmem(gBuff, lHt*lWid);
     lI := 0;
     for lPos := 1 to (lHt) do begin
         for lR := 1 to lWid do begin
             lX := lR mod 256;
             inc(lI);
             gBuff[lI] := lX;
         end;
     end;
     SetDimensionGrayscale(ImageSrc, gSrcHt,gSrcWid, gBuff);
end;

procedure TForm1.CopyInput;
var
   lX,lY,lPos,lBMPWid, lBMPHt: integer;
begin
     lBMPHt := BMPImage.Picture.Height;
     if gSrcHt < lBMPHt then
        gSrcHt := lBMPHt;
     lBMPWid := BMPImage.Picture.Width;
     if gSrcWid < lBMPWid then
        gSrcWid := lBMPWid;
     DrawInput(gSrcHt,gSrcWid);
     for lY := 0 to (lBMPHt-1) do begin
         lPos := ((lBMPHt-lY)) * gSrcWid;
         for lX := 0 to (lBMPWid-1) do begin
             inc(lPos);
             gBuff[lPos] := BMPImage.Canvas.Pixels[lX,lY];
         end;
     end;
     SetDimensionGrayscale(ImageSrc, gSrcHt,gSrcWid, gBuff);
end;

procedure TForm1.ShowLUT;
var
   lSz,lPos,lL,lB: integer;
   lCh: char;
begin
     lSz := kBinMax + kBorder+kBorder;

     ImageLUT.Width := lSz;
     ImageLUT.Height := lSz;
     with ImageLUT.Canvas do begin
          Brush.Color := clWhite;
          FillRect(Rect(0,0,lSz,lSz));
          lL := kBorder;
          lB := kBinMax+kBorder+(kBorder shr 1); //kBorder;
          Pen.width := 3;
          //red
          Pen.Color := clRed;
          MoveTo(lL,lB-gRLUT[0]);
          for lPos := 1 to kBinMax do
              LineTo(lL+lPos,lB-gRLUT[lPos]);
          //green
          lB := lB -4;//offset
          Pen.Color := clGreen;
          MoveTo(lL,lB-gGLUT[0]);
          for lPos := 1 to kBinMax do
              LineTo(lL+lPos,lB-gGLUT[lPos]);
          //blue
          lB := lB -4;//offset
          Pen.Color := clBlue;
          MoveTo(lL,lB-gBLUT[0]);
          for lPos := 1 to kBinMax do
              LineTo(lL+lPos,lB-gBLUT[lPos]);
          if DepCheck.checked then
             lCh := 'M'
          else
              lCh := ' ';
          TextOut(6,1,lCH+' Bias/Gain Values R:'+inttostr(RBias.Position)+'/'+inttostr(RGain.Position)+
             ' G:'+inttostr(GBias.Position)+'/'+inttostr(GGain.Position)+
             ' B:'+inttostr(BBias.Position)+'/'+inttostr(BGain.Position) );
     end;//with canvas
end;

procedure LoadBMP(lFilename: string);
begin
    if not fileexists(lFilename) then exit;
    Form1.BMPImage.Picture.LoadFromFile(lFilename);
    Form1.CopyInput;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
   lP: integer;
begin
     Randomize;
     getmem(gBuff,16);
     for lP := 0 to kBinMax do
         gRLUT[lP] := lP;
     for lP := 1 to kBinMax do
         gGLUT[lP] := lP;
     for lP := 1 to kBinMax do
         gBLUT[lP] := lP;
     DrawInput(kRectSz,kRectSz);
     LoadBMP(extractfiledir(paramstr(0))+'\ch2.bmp');
     ShowLUT;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
          freemem(gBuff);
end;

procedure TForm1.OpenBMPBtnClick(Sender: TObject);
begin
     if  OpenDialog1.execute then begin
         LoadBMP (changefileext(OpenDialog1.filename,'.bmp'));
         exit;
     end;
     //else failure...
     DrawInput(kRectSz,kRectSz);
     ShowLUT;
end;

procedure TForm1.CopyBtnClick(Sender: TObject);
var
  MyFormat : Word;
  AData: THandle;
  APalette : HPalette;   //For later versions of Delphi: APalette : THandle;
begin
	 if (ImageLUT.Picture.Graphic = nil) then begin //1420z
		Showmessage('You need to create an image before you can copy it to the clipboard.');
		exit;
	 end;
	 ImageLUT.Picture.SaveToClipBoardFormat(MyFormat,AData,APalette);
	 ClipBoard.SetAsHandle(MyFormat,AData)
end;

procedure TForm1.ClearBtnClick(Sender: TObject);
begin
        DrawInput(kRectSz,kRectSz);
        ShowLut;
        //SmoothEditChange(nil);
end;


procedure LUThorz (lBiasIn: integer;var  lLUT: TLUT);
var
   lI,lIndex: integer;
begin
     lI := round(((lBiasIn)/100) * 255);
	 for lIndex := 1 to (kBinMax-1) do
		 lLUT[lIndex] := lI;

end;


procedure LUTbiasX (lBiasIn,lGainIn: integer;var  lLUT: TLUT);
{http://dept-info.labri.fr/~schlick/DOC/gem2.html
http://dept-info.labri.fr/~schlick/publi.html
Fast Alternatives to Perlin's Bias and Gain Functions
Christophe Schlick Graphics Gems IV, p379-382, April 1994  }
var
	lIndex: integer;
	lA,lT,lBias,lG,lGain,lResult: single;
	//lLUT: TLUT;
begin
        if lGainIn > 100 then begin
           LUTHorz(lBiasIn,lLUT);
           exit;
        end;
	//if gRender.CutoutBias = 4 then exit;
	lA := (lBiasIn)/100;
        if lA = 0 then
           lA := 0.000001;
	lG := (lGainIn)/100;
        if lG = 0 then
           lG := 0.00001;
        if lG = 1 then
           lG := 0.99999;
	 for lIndex := 1 to (kBinMax-1) do begin
		 lT := lIndex/255;
                 //apply bias
		 lBias := (lt/((1/la-2)*(1-lt)+1)) ;
                 //next apply gain
                 if lT < 0.5 then
                      lGain := (lT/((1/lG-2)*(1-2*lT)+1))
                 else
                     lGain := (( (1/lG-2)*(1-2*lT)-lT ) / ( (1/lG-2)*(1-2*lT)-1 ) );
                 lGain := lGain / (lIndex/kBinMax);
                 lResult := (255*lBias*lGain);
                 if lResult > 255 then
                    lResult := 255;
                 if lResult < 0 then
                    lResult := 0;
		 lLUT[lIndex] := round(lResult);
	 end;
end;

procedure LUTbiasZ (lBiasIn,lGainIn: integer;var  lLUT: TLUT);
{http://dept-info.labri.fr/~schlick/DOC/gem2.html
http://dept-info.labri.fr/~schlick/publi.html
Fast Alternatives to Perlin's Bias and Gain Functions
Christophe Schlick Graphics Gems IV, p379-382, April 1994  }
var
	lIndex: integer;
	lA,lT,lBias,lG,lGain,lResult: single;
	//lLUT: TLUT;
begin
        if lGainIn > 100 then begin
           LUTHorz(lBiasIn,lLUT);
           exit;
        end;
	//if gRender.CutoutBias = 4 then exit;
	lA := (lBiasIn)/100;
        if lA = 0 then
           lA := 0.000001;
	lG := (lGainIn)/100;
        if lG = 0 then
           lG := 0.00001;
        if lG = 1 then
           lG := 0.99999;
	 for lIndex := 1 to (kBinMax-1) do begin
		 lT := lIndex/255;
                 //apply bias
		 lT := (lt/((1/la-2)*(1-lt)+1)) ;
                 //next apply gain
                 if lT < 0.5 then
                      lGain := (lT/((1/lG-2)*(1-2*lT)+1))
                 else
                     lGain := (( (1/lG-2)*(1-2*lT)-lT ) / ( (1/lG-2)*(1-2*lT)-1 ) );
                 lGain := lGain / lT;
                 lResult := (255*lT*lGain);
                 if lResult > 255 then
                    lResult := 255;
                 if lResult < 0 then
                    lResult := 0;
		 lLUT[lIndex] := round(lResult);
	 end;
end;


procedure TForm1.RBiasChange(Sender: TObject);
begin
 if DepCheck.checked then begin
     LUTBiasZ(RBias.position,RGain.position,gRLUT);
     LUTBiasZ(GBias.position,GGain.position,gGLUT);
     LUTBiasZ(BBias.position,BGain.position,gBLUT);
 end else begin
     LUTBiasX(RBias.position,RGain.position,gRLUT);
     LUTBiasX(GBias.position,GGain.position,gGLUT);
     LUTBiasX(BBias.position,BGain.position,gBLUT);
 end;
 ShowLUT;
 SetDimensionGrayscale(ImageSrc, gSrcHt,gSrcWid, gBuff);
end;

procedure TForm1.ResetClick(Sender: TObject);
begin
     RBias.position := 50;
     GBias.position := 50;
     BBias.position := 50;
     RGain.position := 50;
     GGain.position := 50;
     BGain.position := 50;
 RBiasChange(nil);
end;

procedure TForm1.SaveBtnClick(Sender: TObject);
var
   lFdata: file;
   lFilename: string;
begin
     if not SaveDialog1.Execute then
        exit;
     lFilename := changefileext(SaveDialog1.Filename,'.lut');
     {if fileexists(lFilename) then begin
         showmessage('Error: file exists named '+lFilename);
         exit;
     end;}
     AssignFile(lFData, lFilename{'C:\Documents and Settings\Chris Rorden\My Documents\niftiview\lut\hyper.lut'});
     Rewrite(lFData,1);
     BlockWrite(lFdata, gRLUT, kBinMax+1);
     BlockWrite(lFdata, gGLUT, kBinMax+1);
     BlockWrite(lFdata, gBLUT, kBinMax+1);
     CloseFile(lFData);

end;

procedure TForm1.RandBtnClick(Sender: TObject);
begin
     RBias.position := random(101);
     GBias.position := random(101);
     BBias.position := random(101);
     RGain.position := random(101);
     GGain.position := random(101);
     BGain.position := random(101);
RBiasChange(nil);
end;

procedure TForm1.RBtnClick(Sender: TObject);
begin
    RBias.position := 50;
    RGain.position := 50;
     RBiasChange(nil);
end;

procedure TForm1.GBtnClick(Sender: TObject);
begin
    GBias.position := 50;
    GGain.position := 50;
     RBiasChange(nil);
end;

procedure TForm1.BBtnClick(Sender: TObject);
begin
    BBias.position := 50;
    BGain.position := 50;
     RBiasChange(nil);
end;

procedure TForm1.LUT2txtClick(Sender: TObject);
var
  //lTabName,
  lLUTname, lCLUTName: string;
  lFdata: file;
  lText : TextFile;
  I: integer;
begin
  if not OpenDialog2.execute then exit;
  lLUTname :=  OpenDialog2.filename;
  (*lTabName := changefileext(OpenDialog2.filename,'.tab');
  if fileexists(lTabName) then begin
    showmessage('Unable to convert LUT as text file already exists: '+lTabName);
    exit;
  end;    *)
  lCLUTName := changefileext(OpenDialog2.filename,'.clut');
  if fileexists(lCLUTName) then begin
    showmessage('Unable to convert LUT as CLUT file already exists: '+lCLUTName);
    exit;
  end;
  //read binary data
  AssignFile(lFData, lLUTname);
  FileMode := fmOpenRead;
  Reset(lFData,1);
  BlockRead(lFdata, gRLUT, kBinMax+1);
  BlockRead(lFdata, gGLUT, kBinMax+1);
  BlockRead(lFdata, gBLUT, kBinMax+1);
  CloseFile(lFData);
  //write text file
  (*AssignFile(lText, lTabName);
  FileMode := fmOpenWrite;
  Rewrite(lText);
   Writeln(lText, 'Red'+chr(9)+'Green'+chr(9)+'Blue' );
  for I:=0 to 255 do
    Writeln(lText, inttostr( gRLUT[I]) +chr(9)+inttostr(  gGLUT[I])+ chr(9) + inttostr( gBLUT[I]) );
  CloseFile(lText); *)
  //write to CLUT file
  AssignFile(lText, lCLUTName);
  FileMode := fmOpenWrite;
  Rewrite(lText);
   Writeln(lText, '[FLT]' );
   Writeln(lText, 'min=0' );
   Writeln(lText, 'max=0' );
   Writeln(lText, '[INT]' );
   Writeln(lText, 'numnodes=256' );
   Writeln(lText, '[BYT]' );
    for I:=0 to 255 do
      Writeln(lText, 'nodeintensity'+inttostr(I)+'='+inttostr(I) );
   Writeln(lText, '[RGBA255]' );
  for I:=0 to 255 do
    Writeln(lText,'nodergba'+inttostr(I)+'='+inttostr( gRLUT[I]) +'|'+inttostr( gGLUT[I]) +'|'+ inttostr( gBLUT[I]) +'|'+inttostr(I div 2) );

  CloseFile(lText);
  //finish up
  FileMode := fmOpenReadWrite;
  Showmessage('Converted lut to tab-delimited text file you can open with a spreadsheet '+lCLUTName);
end;

end.
